with System; use System;
with Glib; use Glib;
with Gdk.Event; use Gdk.Event;
with Gdk.Types; use Gdk.Types;
with Gtk.Accel_Group; use Gtk.Accel_Group;
with Gtk.Object; use Gtk.Object;
with Gtk.Enums; use Gtk.Enums;
with Gtk.Style; use Gtk.Style;
with Gtk.Widget; use Gtk.Widget;

with Gdk.Main;
with Ada.Text_IO;

package body Window1_Pkg.Callbacks is

   use Gtk.Arguments;

   ----------------------
   -- On_Right_Toggled --
   ----------------------

   procedure On_Right_Toggled
     (Object : access Gtk_Radio_Button_Record'Class)
   is
      type Window_Access is access all Window1_Record'Class;
      Window : Window_Access := Window_Access (Get_Toplevel (Object));
   begin
      if Get_Active (Object) then
         Window.Correct := True;
      end if;
   end On_Right_Toggled;

   ----------------------
   -- On_Dunno_Toggled --
   ----------------------

   procedure On_Dunno_Toggled
     (Object : access Gtk_Radio_Button_Record'Class)
   is
      type Window_Access is access all Window1_Record'Class;
      Window : Window_Access := Window_Access (Get_Toplevel (Object));
   begin
      if Get_Active (Object) then
         Window.Correct := Maybe;
      end if;
   end On_Dunno_Toggled;

   ----------------------
   -- On_Wrong_Toggled --
   ----------------------

   procedure On_Wrong_Toggled
     (Object : access Gtk_Radio_Button_Record'Class)
   is
      type Window_Access is access all Window1_Record'Class;
      Window : Window_Access := Window_Access (Get_Toplevel (Object));
   begin
      if Get_Active (Object) then
         Window.Correct := False;
      end if;
   end On_Wrong_Toggled;

   ----------
   -- Quit --
   ----------

   procedure Quit
     (Object : access Gtk_Button_Record'Class)
   is
   begin
      Gdk.Main.Gdk_Exit (Error_Code => 1);
   end Quit;

   ----------
   -- Done --
   ----------

   procedure Done
     (Object : access Gtk_Button_Record'Class)
   is
      use Ada.Text_IO;
      type Window_Access is access all Window1_Record'Class;
      Window : Window_Access := Window_Access (Get_Toplevel (Object));
   begin
      Put_Line ("WORD: " & Get_Text (Window.Word));
      case Window.Correct is
         when True =>
            Put_Line ("STATUS: +");
         when Maybe =>
            Put_Line ("STATUS: ?");
         when False =>
            Put_Line ("STATUS: -");
      end case;
      New_Line;
      Gdk.Main.Gdk_Exit (Error_Code => 0);
   end Done;

end Window1_Pkg.Callbacks;
