with Glib; use Glib;
with Gtk; use Gtk;
with Gdk.Types; use Gdk.Types;
with Gtk.Widget; use Gtk.Widget;
with Gtk.Enums; use Gtk.Enums;
with Gtkada.Handlers; use Gtkada.Handlers;
with Callbacks_Proof_Reading_Tool; use Callbacks_Proof_Reading_Tool;
with Proof_Reading_Tool_Intl; use Proof_Reading_Tool_Intl;
with Window1_Pkg.Callbacks; use Window1_Pkg.Callbacks;

with Ada.Command_Line;

package body Window1_Pkg is

procedure Gtk_New (Window1 : out Window1_Access) is
begin
   Window1 := new Window1_Record;
   Window1_Pkg.Initialize (Window1);
end Gtk_New;

procedure Initialize (Window1 : access Window1_Record'Class) is
   use Ada.Command_Line;
   pragma Suppress (All_Checks);
   Pixmaps_Dir : constant String := "pixmaps/";
   Vbox2_Group : Widget_SList.GSList;

begin
   Gtk.Window.Initialize (Window1, Window_Toplevel);
   Set_Title (Window1, "Proof-reading " & Argument (1));
   Set_Position (Window1, Win_Pos_None);
   Set_Modal (Window1, False);

   Gtk_New_Vbox (Window1.Vbox1, False, 0);
   Add (Window1, Window1.Vbox1);

   Gtk_New (Window1.Notebook1);
   Set_Scrollable (Window1.Notebook1, False);
   Set_Show_Border (Window1.Notebook1, True);
   Set_Show_Tabs (Window1.Notebook1, True);
   Set_Tab_Pos (Window1.Notebook1, Pos_Top);
   Pack_Start
     (Window1.Vbox1,
      Window1.Notebook1,
      Expand  => True,
      Fill    => True,
      Padding => 0);

   Gtk_New_Vbox (Window1.Vbox2, False, 0);
   Append_Page (Window1.Notebook1, Window1.Vbox2);
   Set_Tab_Label_Packing (Window1.Notebook1, Window1.Vbox2, False, True, Pack_Start);

   Gtk_New_Hbox (Window1.Hbox1, False, 0);
   Pack_Start
     (Window1.Vbox2,
      Window1.Hbox1,
      Expand  => True,
      Fill    => True,
      Padding => 0);

   Gtk_New (Window1.Label2, -("Word:"));
   Set_Alignment (Window1.Label2, 0.5, 0.5);
   Set_Padding (Window1.Label2, 0, 0);
   Set_Justify (Window1.Label2, Justify_Left);
   Set_Line_Wrap (Window1.Label2, False);
   Set_Selectable (Window1.Label2, False);
   Set_Use_Markup (Window1.Label2, False);
   Set_Use_Underline (Window1.Label2, False);
   Pack_Start
     (Window1.Hbox1,
      Window1.Label2,
      Expand  => False,
      Fill    => False,
      Padding => 0);

   Gtk_New (Window1.Word);
   Set_Editable (Window1.Word, False);
   Set_Max_Length (Window1.Word, 0);
   Set_Text (Window1.Word, Ada.Command_Line.Argument (1));
   Set_Visibility (Window1.Word, True);
   Set_Invisible_Char (Window1.Word, UTF8_Get_Char ("*"));
   Pack_Start
     (Window1.Hbox1,
      Window1.Word,
      Expand  => True,
      Fill    => True,
      Padding => 0);

   Gtk_New (Window1.Right, null, -("_Right"));
   Set_Relief (Window1.Right, Relief_Normal);
   Set_Active (Window1.Right, False);
   Set_Inconsistent (Window1.Right, False);
   Set_Relief (Window1.Right, Relief_Normal);
   Set_Use_Underline (Window1.Right, True);
   Pack_Start
     (Window1.Vbox2,
      Window1.Right,
      Expand  => False,
      Fill    => False,
      Padding => 0);
   Radio_Button_Callback.Connect
     (Window1.Right, "toggled",
      Radio_Button_Callback.To_Marshaller (On_Right_Toggled'Access), False);

   Gtk_New (Window1.Dunno, Window1.Right, -("_Dunno"));
   Set_Relief (Window1.Dunno, Relief_Normal);
   Set_Active (Window1.Dunno, True);
   Set_Inconsistent (Window1.Dunno, False);
   Set_Relief (Window1.Dunno, Relief_Normal);
   Set_Use_Underline (Window1.Dunno, True);
   Pack_Start
     (Window1.Vbox2,
      Window1.Dunno,
      Expand  => False,
      Fill    => False,
      Padding => 0);
   Radio_Button_Callback.Connect
     (Window1.Dunno, "toggled",
      Radio_Button_Callback.To_Marshaller (On_Dunno_Toggled'Access), False);

   Gtk_New (Window1.Wrong, Window1.Right, -("_Wrong"));
   Set_Relief (Window1.Wrong, Relief_Normal);
   Set_Active (Window1.Wrong, False);
   Set_Inconsistent (Window1.Wrong, False);
   Set_Relief (Window1.Wrong, Relief_Normal);
   Set_Use_Underline (Window1.Wrong, True);
   Pack_Start
     (Window1.Vbox2,
      Window1.Wrong,
      Expand  => False,
      Fill    => False,
      Padding => 0);
   Radio_Button_Callback.Connect
     (Window1.Wrong, "toggled",
      Radio_Button_Callback.To_Marshaller (On_Wrong_Toggled'Access), False);

   Gtk_New (Window1.Label1, -("Spelling"));
   Set_Alignment (Window1.Label1, 0.5, 0.5);
   Set_Padding (Window1.Label1, 0, 0);
   Set_Justify (Window1.Label1, Justify_Left);
   Set_Line_Wrap (Window1.Label1, False);
   Set_Selectable (Window1.Label1, False);
   Set_Use_Markup (Window1.Label1, False);
   Set_Use_Underline (Window1.Label1, False);
   Set_Tab (Window1.Notebook1, 0, Window1.Label1);

   Gtk_New (Window1.Hbuttonbox1);
   Set_Spacing (Window1.Hbuttonbox1, 0);
   Set_Layout (Window1.Hbuttonbox1, Buttonbox_Default_Style);
   Pack_Start
     (Window1.Vbox1,
      Window1.Hbuttonbox1,
      Expand  => True,
      Fill    => True,
      Padding => 0);

   Gtk_New_From_Stock (Window1.Button1, "gtk-cancel");
   Set_Relief (Window1.Button1, Relief_Normal);
   Set_Flags (Window1.Button1, Can_Default);
   Button_Callback.Connect
     (Window1.Button1, "clicked",
      Button_Callback.To_Marshaller (Quit'Access), False);
   Pack_Start (Window1.Hbuttonbox1, Window1.Button1);

   Gtk_New_From_Stock (Window1.Button2, "gtk-ok");
   Set_Relief (Window1.Button2, Relief_Normal);
   Set_Flags (Window1.Button2, Can_Default);
   Button_Callback.Connect
     (Window1.Button2, "clicked",
      Button_Callback.To_Marshaller (Done'Access), False);
   Pack_Start (Window1.Hbuttonbox1, Window1.Button2);

   Gtk_New_From_Stock (Window1.Button3, "gtk-go-forward");
   Set_Relief (Window1.Button3, Relief_Normal);
   Set_Flags (Window1.Button3, Can_Default);
   Pack_Start (Window1.Hbuttonbox1, Window1.Button3);

end Initialize;

end Window1_Pkg;
